#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityKingCraftSignCFG.h"
std::auto_ptr<M_ActivityKingCraftSignCFG> M_ActivityKingCraftSignCFG::msSingleton(nullptr);

int M_ActivityKingCraftSignCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityKingCraftSignCFGData* M_ActivityKingCraftSignCFG::GetData(int Day)
{
	auto it = mMapData.find(Day);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityKingCraftSignCFGData>& M_ActivityKingCraftSignCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityKingCraftSignCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityKingCraftSignCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityKingCraftSignCFGData data;
		data.mDay = element->IntAttribute("Day");
		{
			const char* Item = element->Attribute("Item");
			std::vector<std::string> vecItem;
			boost::split(vecItem, Item, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItem[i].c_str(), &temp))
				{
					data.mItem.push_back(temp);
				}
			}
		}
		{
			const char* Count = element->Attribute("Count");
			std::vector<std::string> vecCount;
			boost::split(vecCount, Count, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCount[i].c_str(), &temp))
				{
					data.mCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityKingCraftSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityKingCraftSignCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityKingCraftSignCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityKingCraftSignCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityKingCraftSignCFGData data;
		LuaCfgHelper::readInt(L, "Day", data.mDay);
		LuaCfgHelper::readVectorInt(L, "Item", data.mItem);
		LuaCfgHelper::readVectorInt(L, "Count", data.mCount);
		if (mMapData.find(data.mDay) != mMapData.end())std::cout <<"data refind:" << data.mDay << std::endl;
		CCASSERT(mMapData.find(data.mDay) == mMapData.end(), "data.mDay is exists");
		mMapData.insert(std::make_pair(data.mDay, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityKingCraftSignCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityKingCraftSignCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityKingCraftSignCFG* M_ActivityKingCraftSignCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityKingCraftSignCFG());
	}
	return msSingleton.get();
}

void M_ActivityKingCraftSignCFG::Release()
{
	msSingleton.reset(nullptr);
}
